#include <Pilot.h>
#include "ui.h"

#define MHDCreator 'MHDP'
#define TypLinka 'LINK'
#define TypInfo 'INFO'
#define MAXZNAKU 30

#define MAXRADEK 34
#define MAXLIST 100

typedef struct{
  UInt index;
  char nazev[30];
}rec_v_xs;

typedef struct{
  UInt idz;
  UInt linka;
}rec_v_lin;

static char name[]="ALOKUJEMENEJAKEMISTO";
static char name_is[]="zast_is";
static char name_js[]="zast_js";
static char name_lin[]="zast_lin";
static char nejede[]="NEJEDE";
static char nenalzast[]="V TOMTO SMERU NEJEDE";
static char prazdnystring[]="";

static DmOpenRef soubor_is=NULL;
static VoidPtr is_lock=NULL;
static DmOpenRef soubor_js=NULL;
static VoidPtr js_lock=NULL;
static DmOpenRef soubor_lin=NULL;
static VoidPtr lin_lock=NULL;
static DmOpenRef soubor_vyb_linky=NULL;
static VoidPtr vlin_lock=NULL;

static char vybr_linka[]="0123";
static CharPtr vybr_zast;

static Boolean uz_datum=false;
static UInt ted_hodina;
static UInt ted_den;

static Boolean smer_tam=true;


static char TxtTab[MAXLIST][40];
static UInt idz_in_form[MAXLIST];
static UInt idz_index=-1;
static UInt hod_in_form[MAXLIST];
static UInt vybr_hodina=-1;

/* moje nahrada StrPrintF pro PalmOS2 */
static void MyStrPrintF(CharPtr kam, UInt cislo){
  char tmp[]="abcde";

  if(cislo>9){
    StrIToA(kam,cislo);
  }
  else{
    StrCopy(kam,"0");
    StrIToA(tmp,cislo);
    StrCat(kam,tmp);
  }
  

}

/*Formulari "Field" danemu svym ID priradi novy text*/
static void SetFieldTextFromPtr(Word fieldID, CharPtr txtP){
    FormPtr frm = FrmGetActiveForm();
    FieldPtr fldP;

    fldP = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, fieldID));

    FldSetTextPtr(fldP, txtP);
    FldDrawField(fldP);
}

/* Start programu */
static UInt Start (void)
{
  UInt CardNo=0;
  LocalID LocID;
  DmSearchStateType statePtr;
  Boolean is=false;
  Boolean js=false;
  Boolean lin=false;
  VoidHand v=NULL; 

  /* Hledame datove soubory */
  if(!DmGetNextDatabaseByTypeCreator(true,&statePtr,TypInfo,MHDCreator,false,&CardNo,&LocID)){
       DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0);
       if(!StrCompare(name,name_is)){
	 if(soubor_is=DmOpenDatabase(CardNo,LocID,dmModeReadOnly)){
	   v=DmQueryRecord(soubor_is,0);   
	   is_lock=MemHandleLock(v);	   
           is=true;	   
	 }
       }
       if(!StrCompare(name,name_js)){
	 if(soubor_js=DmOpenDatabase(CardNo,LocID,dmModeReadOnly)){	
	   v=DmQueryRecord(soubor_js,0);   
	   js_lock=MemHandleLock(v);	
	   js=true;	   
	 }
       }
       if(!StrCompare(name,name_lin)){	 
	 if(soubor_lin=DmOpenDatabase(CardNo,LocID,dmModeReadOnly)){
	    v=DmQueryRecord(soubor_lin,0);   
	    lin_lock=MemHandleLock(v);	
	    lin=true;       
	 }
       }
 
     //dalsi
     while(!DmGetNextDatabaseByTypeCreator(false,&statePtr,TypInfo,MHDCreator,false,&CardNo,&LocID)){
       DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0);
       if(!StrCompare(name,name_is)){
	 if(soubor_is=DmOpenDatabase(CardNo,LocID,dmModeReadOnly)){
	   v=DmQueryRecord(soubor_is,0);   
	   is_lock=MemHandleLock(v);	   
           is=true;	   
	 }
       }
       if(!StrCompare(name,name_js)){
	 if(soubor_js=DmOpenDatabase(CardNo,LocID,dmModeReadOnly)){	
	   v=DmQueryRecord(soubor_js,0);   
	   js_lock=MemHandleLock(v);	
	   js=true;	   
	 }
       }
       if(!StrCompare(name,name_lin)){	 
	 if(soubor_lin=DmOpenDatabase(CardNo,LocID,dmModeReadOnly)){
	    v=DmQueryRecord(soubor_lin,0);   
	    lin_lock=MemHandleLock(v);	
	    lin=true;       
	 }
       }
     }
     if(!is) {FrmAlert(AlertNIS);return 0;}
     else {if(!js) {FrmAlert(AlertNJS);return 0;}
           else{ if(!lin) {FrmAlert(AlertNLI);return 0;}
	         else {FrmGotoForm(MainForm); return 1;}
	  }
     }
  }
  else {FrmAlert(AlertFNF);return 0;}
}

/* Postupne vyhledavani */
static void UpdateHledani(){
 UInt CardNo=0;
 LocalID LocID;
 FormPtr frm;
 ControlPtr cpz;  
 ControlPtr cpl;  
 DmSearchStateType statePtr;
 VoidHand myHandle = NULL;
 VoidHand myHandle2 = NULL;
 UInt zaznamu = 0;
 UInt index = 0;
 UInt index2 = 0;
 ListPtr lp;
 FieldPtr fp;
 CharPtr h;
 static CharPtr it_pole[MAXLIST];
 VoidHand v=NULL;
 VoidPtr rec_arr;
 rec_v_xs * one_rec;
 CharPtr cc;
 UInt i,j;
 CharPtr k; 

 Word frmID = FrmGetActiveFormID();
 if(frmID==MainForm){ //je to 1. formular
      frm = FrmGetActiveForm();               
      lp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, LstVyhledany));   
      cpz = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshZastavka));  
      cpl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshLinka));
      fp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, FldHledaci));
      h = FldGetTextPtr(fp);

      if(!h || StrLen(h)<1)return;
      if(CtlGetValue(cpz)){ //hleda zastavku
	    rec_arr=js_lock;
	    for(index=0;index<(MemPtrSize(rec_arr)/sizeof(rec_v_xs));index++){	   
	        one_rec=(rec_v_xs*)(rec_arr+(sizeof(rec_v_xs)*index));	      
		if(!StrNCaselessCompare(one_rec->nazev,h,StrLen(h))){
		  if(index2<MAXLIST){
		     idz_in_form[index2]=one_rec->index;
	             it_pole[index2++]=one_rec->nazev;
		  }
	        }		
	    }
		 
	LstSetListChoices(lp, it_pole, index2);
        FrmDrawForm(frm);	 
      }

      if(CtlGetValue(cpl)){ //hleda linku	    	
	//hledame podobne se jmenujici databaze
	if(!h || StrLen(h)<1)return;
	if(!DmGetNextDatabaseByTypeCreator(true,&statePtr,TypLinka,MHDCreator,false,&CardNo,&LocID)){
	  if(!DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0)){
	    if(!StrNCompare(name,h,StrLen(h))){
	      //omezeni
	      if(StrLen(name)<=StrLen(h)+1){
		it_pole[zaznamu]=TxtTab[zaznamu];	      
		StrCopy(TxtTab[zaznamu++],name);	     
	      }
	    }
	  }	
	  while(!DmGetNextDatabaseByTypeCreator(false,&statePtr,TypLinka,MHDCreator,false,&CardNo,&LocID)){
	    if(!DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0)){
	      if(!StrNCaselessCompare(name,h,StrLen(h))){
		if(zaznamu<MAXLIST && StrLen(name)<=StrLen(h)+1){
		  it_pole[zaznamu]=TxtTab[zaznamu];		
		  StrCopy(TxtTab[zaznamu++],name);
		}
	      }	   
	    }
	  }

	  //sortime
	  if(zaznamu>0){
	    for(i=0;i<zaznamu-1;i++){
	      for(j=0;j<zaznamu-1;j++){
		if(StrAToI(it_pole[j])>StrAToI(it_pole[j+1])){
		  k=it_pole[j];		
		  it_pole[j]=it_pole[j+1];
		  it_pole[j+1]=k;
		}
	      }
	    }
	  }

	  LstSetListChoices(lp, it_pole, zaznamu);
	  FrmDrawForm(frm);	   
	}
      }
 }
}
      

/* Udalosti v 1. formulari */
static Boolean MainFormEventHandler(EventPtr e)
{
  Boolean handled=false;
  EventType newEvent;
  CharPtr h;
  ListPtr pl;
  FormPtr frm;
  ControlPtr cpz;  
  ControlPtr cpl;  
 
  frm = FrmGetActiveForm();     
  switch (e->eType)
    {
    case ctlSelectEvent:
      switch (e->data.ctlEnter.controlID)
        {
         case PshZastavka:
         case PshLinka:
            UpdateHledani();
            break;   
        }
        break;
    case lstSelectEvent:
         h=LstGetSelectionText(e->data.lstSelect.pList,LstGetSelection(e->data.lstSelect.pList));
	 cpz = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshZastavka));  
	 cpl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshLinka));	 
	 if(h && StrLen(h)>0){
	   if(CtlGetValue(cpl)){ //je vybrana linka
	     StrCopy(vybr_linka,h);	     
	     FrmGotoForm(VybzForm);	  
	   }
	   if(CtlGetValue(cpz)){//je vybrana zastavka
	     vybr_zast=LstGetSelectionText(e->data.lstSelect.pList,LstGetSelection(e->data.lstSelect.pList));
	     idz_index=LstGetSelection(e->data.lstSelect.pList);
	     FrmGotoForm(VyblForm);
	   }
	 }
         break;
    case frmOpenEvent:
      pl = FrmGetObjectPtr(FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), LstVyhledany));
      cpl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshLinka));	 
      CtlSetValue(cpl, 1); //nastavi push linka  
      LstSetSelection(pl,-1);
      FrmDrawForm(frm);
      // FldGrabFocus(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, FldHledaci)));
      handled = true;
      break;
    }
  return(handled);
}


static void  updateLstZastavky(){
  UInt CardNo=0;
  LocalID LocID;
  FormPtr frm;
  DmSearchStateType statePtr;
  Boolean nasel=false;
  static CharPtr it_pole[MAXLIST];
  VoidHand v=NULL;
  VoidPtr rec_arr;
  VoidPtr rec_arr2;
  UInt pocetdni,n,i,j,index,idz;
  rec_v_xs * one_rec;
  ListPtr lp;


   if(!DmGetNextDatabaseByTypeCreator(true,&statePtr,TypLinka,MHDCreator,false,&CardNo,&LocID)){
     if(!DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0)){
	if(!StrCompare(name,vybr_linka)){
	   nasel=true;
	}
     }	
    if(!nasel){
      while(!DmGetNextDatabaseByTypeCreator(false,&statePtr,TypLinka,MHDCreator,false,&CardNo,&LocID)){
	 if(!DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0)){
	    if(!StrCompare(name,vybr_linka)){
	       nasel=true;
	       break;
	    }
	 }
      }
    }
    

    if(nasel){
       
      if(vlin_lock){
	MemPtrUnlock(vlin_lock);
	vlin_lock=NULL;
      }
      if(soubor_vyb_linky){
      	DmCloseDatabase(soubor_vyb_linky);
        soubor_vyb_linky=NULL;
      }
      
      if(vlin_lock){
	MemPtrUnlock(vlin_lock);
	vlin_lock=NULL;
      }
      if(soubor_vyb_linky){
	DmCloseDatabase(soubor_vyb_linky);
	soubor_vyb_linky=NULL;
      }

      soubor_vyb_linky=DmOpenDatabase(CardNo,LocID,dmModeReadOnly);
      v=DmQueryRecord(soubor_vyb_linky,0);   
      vlin_lock=rec_arr=MemHandleLock(v);
      rec_arr2=is_lock;
    
      rec_arr+=sizeof(UInt)*4;
      pocetdni=*((UInt*)rec_arr);

      rec_arr+=sizeof(UInt);
      for(i=0;i<pocetdni;i++){
	rec_arr+=sizeof(UInt);
	n=*((UInt*)rec_arr);
	rec_arr+=sizeof(UInt)*(n+1);
	n=*((UInt*)rec_arr);
	rec_arr+=sizeof(UInt)*(n+1);
      }
      //jsme tam kde jsme chteli
      n=*((UInt*)rec_arr);
      if(!smer_tam){
	rec_arr+=sizeof(UInt)*(2*n+1);
	n=*((UInt*)rec_arr);
      }

      index=0;     
      for(i=0;i<n;i++){//nacitame idz
	rec_arr+=sizeof(UInt);
	idz=*((UInt*)rec_arr);
	//hledame podle id
	for(j=0;j<(MemPtrSize(rec_arr2)/sizeof(rec_v_xs));j++){	   
	  one_rec=(rec_v_xs*)(rec_arr2+(sizeof(rec_v_xs)*j));	      
	  if(one_rec->index==idz){
	    if(index<MAXLIST){
	      idz_in_form[index]=one_rec->index;
	      it_pole[index++]=one_rec->nazev;
	    }
	    break;
	  }		
	}
	rec_arr+=sizeof(UInt);
      }


      frm = FrmGetActiveForm();    
      lp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, LstZast));   
      LstSetListChoices(lp, it_pole, index);
      FrmDrawForm(frm);	  
    }
   }
    
}

/* Udalosti z formulare vyberu zastavky */
static Boolean vybzFormEventHandler(EventPtr e){
  Boolean handled=false;

  switch (e->eType)
    {
    case ctlSelectEvent:
      switch (e->data.ctlEnter.controlID){
        case BtnZpet2:	
	  FrmGotoForm(MainForm); //stisk tlacitka "novy vyber", navrat na 1. formular
	  break; 
        case ZmenSmer:
	  smer_tam=!smer_tam;
	  updateLstZastavky();
	  break;
      }
      break;
    case frmOpenEvent: 
       SetFieldTextFromPtr(FldJmenoLinky,vybr_linka);
       updateLstZastavky(); //prepise novymi daty
       handled=true;    
       FrmDrawForm(FrmGetActiveForm());	   
       break;

    case lstSelectEvent:    
       vybr_zast=LstGetSelectionText(e->data.lstSelect.pList,LstGetSelection(e->data.lstSelect.pList));
       idz_index=LstGetSelection(e->data.lstSelect.pList);
       FrmGotoForm(IntervalyForm);   
       break;
    }
  
  return handled;
}


/*Nastavi List autobusy a tramvaje*/
static void updateLstLinky(){
  VoidHand v=NULL;
  VoidPtr rec_arr;
  rec_v_xs * one_rec;
  rec_v_lin * one_rec2;
  UInt idz;
  UInt index=0;
  UInt index2=0;
  UInt index3=0;
  UInt i=0;
  static CharPtr it_pole[MAXLIST];
  static CharPtr it_pole2[MAXLIST];

  FormPtr frm = FrmGetActiveForm();
  ListPtr lpB = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, LstBus));   
  ListPtr lpT = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, LstTram));   

  //hledame idz vybrane zastavky
  /* rec_arr=js_lock;
  
  for(i=0;i<(MemPtrSize(rec_arr)/sizeof(rec_v_xs));i++){	   
      one_rec=(rec_v_xs*)(rec_arr+(sizeof(rec_v_xs)*i));	      
      if(!StrCompare(one_rec->nazev,vybr_zast)){
	idz=one_rec->index;
	break;
      }
      }*/

  idz=idz_in_form[idz_index];

  //hledame co je za linky na teto zastavce
  rec_arr=lin_lock;
  for(i=0; i < (MemPtrSize(rec_arr)/sizeof(rec_v_lin)) ; i++){	 
      one_rec2=(rec_v_lin*)(rec_arr+sizeof(rec_v_lin)*i);    
      if(one_rec2->idz==idz){
	if(one_rec2->linka>100){//BUS
	  if(index<MAXLIST)
	    it_pole[index++]=StrIToA(TxtTab[index3++],one_rec2->linka);
	}
	else{//TRAM
	  if(index2<MAXLIST)
	    it_pole2[index2++]=StrIToA(TxtTab[index3++],one_rec2->linka);
	}
      }
  }

  LstSetListChoices(lpB, it_pole, index);
  LstSetListChoices(lpT, it_pole2, index2);

  FrmDrawForm(frm);  

}

/* Udalosti z formulare vyberu linky */
static Boolean vyblFormEventHandler(EventPtr e){
  Boolean handled=false;
  CharPtr h;

  switch (e->eType)
    {
    case ctlSelectEvent:
       switch (e->data.ctlEnter.controlID){
        case BtnZpet:	
	  FrmGotoForm(MainForm); //stisk tlacitka "novy vyber", navrat na 1. formular
	  break;        
       }
       break;
    case frmOpenEvent: 
       SetFieldTextFromPtr(FldJmenoZastavky,vybr_zast);
       updateLstLinky();
       handled=true;    
       FrmDrawForm(FrmGetActiveForm());	   
       break;

    case lstSelectEvent:    
       h=LstGetSelectionText(e->data.lstSelect.pList,LstGetSelection(e->data.lstSelect.pList)); 
       if(h && StrLen(h)>0){	  
	  StrCopy(vybr_linka,h);
	  FrmGotoForm(IntervalyForm);	
       }
       break;
    }
  
  return handled;
}

/* Nastavi spravny push podle dne */
static void dnesek(){

      ControlPtr cp;
      ULong dnes;
      DateTimeType datum;
      FormPtr frm = FrmGetActiveForm();    

      dnes=TimGetSeconds();
      TimSecondsToDateTime(dnes,&datum);

      if(!uz_datum){
	ted_hodina=datum.hour;
	ted_den=datum.weekDay;
      }
      else ted_hodina=hod_in_form[vybr_hodina];
      

      switch(ted_den){
      case 0:  // nedele
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshNedele)); 
	CtlSetValue(cp, 1); 
	break;
      case 1:  // pondeli
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshPondeli)); 
	CtlSetValue(cp, 1);
	break;
      case 2:  // utery
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshUtery)); 
	CtlSetValue(cp, 1); 
	break;
      case 3:  // streda
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshStreda)); 
	CtlSetValue(cp, 1); 
	break;
      case 4:  // ctvrtek
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshCtvrtek)); 
	CtlSetValue(cp, 1); 
	break;
      case 5:  // patek
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshPatek)); 
	CtlSetValue(cp, 1); 
	break;
      case 6:  // sobota
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshSobota)); 
	CtlSetValue(cp, 1); 
	break;
      }

}

static void updateLstIntervaly(){
  UInt CardNo=0;
  LocalID LocID;
  FormPtr frm;
  DmSearchStateType statePtr;
  Boolean nasel=false;
  static CharPtr it_pole[MAXLIST];
  static char radek [MAXRADEK];
  VoidHand v=NULL;
  VoidPtr rec_arr;
  VoidPtr rec_arr2;
  UInt pocetdni,n,i,j,index,idz;
  rec_v_xs * one_rec;
  ListPtr lp;

  ControlPtr cp;
  ULong dnes;
  DateTimeType datum;
  UInt denvsouboru;
  UInt rokvsouboru;
  UInt bitovedatum;
  VoidPtr vyjezdy;
  UInt interval;
  UInt cas,h,m,lh,nidz,vyb_radek;


  Boolean nenizast=false;

  frm = FrmGetActiveForm();    
  
  if(!DmGetNextDatabaseByTypeCreator(true,&statePtr,TypLinka,MHDCreator,false,&CardNo,&LocID)){
     if(!DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0)){
	if(!StrCompare(name,vybr_linka)){
	   nasel=true;
	}
     }	
    if(!nasel){
      while(!DmGetNextDatabaseByTypeCreator(false,&statePtr,TypLinka,MHDCreator,false,&CardNo,&LocID)){
	 if(!DmDatabaseInfo(CardNo,LocID,name,0,0,0,0,0,0,0,0,0,0)){
	    if(!StrCompare(name,vybr_linka)){
	       nasel=true;
	       break;
	    }
	 }
      }
    }

    if(nasel){
      //nalezli jsme databazi
      if(vlin_lock){
	MemPtrUnlock(vlin_lock);
	vlin_lock=NULL;
      }
      if(soubor_vyb_linky){
	DmCloseDatabase(soubor_vyb_linky);
	soubor_vyb_linky=NULL;
      }
      soubor_vyb_linky=DmOpenDatabase(CardNo,LocID,dmModeReadOnly);
      v=DmQueryRecord(soubor_vyb_linky,0);   
      vlin_lock=rec_arr=MemHandleLock(v);
   
      dnes=TimGetSeconds();
      TimSecondsToDateTime(dnes,&datum);

      

      cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshNedele)); 
      if(CtlGetValue(cp)){     
	ted_den=0;
	bitovedatum=64;} //2^6
      else{	
	cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshPondeli)); 
	if(CtlGetValue(cp)){
	  ted_den=1;
	  bitovedatum=1;} //2^0	  
        else{
	  cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshUtery)); 
	  if(CtlGetValue(cp)){
	    ted_den=2;
	    bitovedatum=2;} //2^1
	  else{
	    cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshStreda)); 
	    if(CtlGetValue(cp)){
	      ted_den=3;
	      bitovedatum=4;} //2^2
	    else{
	      cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshCtvrtek)); 
	      if(CtlGetValue(cp)){
		ted_den=4;
		bitovedatum=8;} //2^3;
	      else{  
		cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshPatek));  
		if(CtlGetValue(cp)){
		  ted_den=5;
		  bitovedatum=16;} //2^4
		else{
		  cp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PshSobota)); 
		  if(CtlGetValue(cp)){
		    ted_den=6;
		    bitovedatum=32;} //2^5
		}
	      }
	    }
	  }
	}
      }
          
            

      denvsouboru=*((UInt*)rec_arr);
      rec_arr+=sizeof(UInt);
      rokvsouboru=*((UInt*)rec_arr);
      //test
      if((rokvsouboru>datum.year) || (rokvsouboru==datum.year && denvsouboru > datum.month*100+datum.day)){
	//teprve vstoupi v platnost
	FrmAlert(AlertBUDE);
      }

      rec_arr+=sizeof(UInt);
      denvsouboru=*((UInt*)rec_arr);
      rec_arr+=sizeof(UInt);
      rokvsouboru=*((UInt*)rec_arr);

      //test
      if((rokvsouboru<datum.year) || (rokvsouboru==datum.year && denvsouboru < datum.month*100+datum.day)){
	//prosla platnost
	FrmAlert(AlertBYL);
      }

      rec_arr+=sizeof(UInt);
      pocetdni=*((UInt*)rec_arr);

      nasel=false;
          
      rec_arr+=sizeof(UInt);
      for(i=0;i<pocetdni;i++){
	if(*((UInt*)rec_arr) & bitovedatum){
	  nasel=true;
	  break;
	}
	rec_arr+=sizeof(UInt);
	n=*((UInt*)rec_arr);
	rec_arr+=sizeof(UInt)*(n+1);
	n=*((UInt*)rec_arr);
	rec_arr+=sizeof(UInt)*(n+1);
      }


      if(nasel){
	//jsme tam kde jsme chteli
	rec_arr+=sizeof(UInt);
	n=*((UInt*)rec_arr);

	if(!smer_tam){
	   rec_arr+=sizeof(UInt)*(n+1);
	   n=*((UInt*)rec_arr);
	}
	//nasli jsme vyjezdy
	vyjezdy=rec_arr;

	rec_arr+=sizeof(UInt)*(n+1);
	if(smer_tam){
	   n=*((UInt*)rec_arr);
	   rec_arr+=sizeof(UInt)*(n+1);
	}
	
	//dojedeme zbytek
	for(j=i+1;j<pocetdni;j++){	
	  rec_arr+=sizeof(UInt);
	  n=*((UInt*)rec_arr);
	  rec_arr+=sizeof(UInt)*(n+1);
	  n=*((UInt*)rec_arr);
	  rec_arr+=sizeof(UInt)*(n+1);
	}	
      


	//jsme na zacatku intervalu 
	n=*((UInt*)rec_arr);
	if(!smer_tam){
	  rec_arr+=sizeof(UInt)*(2*n+1);
	  n=*((UInt*)rec_arr);
	}

        rec_arr2=js_lock;

	/*
	nidz=0;
	for(i=0;i<(MemPtrSize(rec_arr2)/sizeof(rec_v_xs));i++){	   
	    one_rec=(rec_v_xs*)(rec_arr2+(sizeof(rec_v_xs)*i));	      	
	    if(!StrCompare(one_rec->nazev,vybr_zast)){
	      nidz=one_rec->index;
	      break;
	    }
	    }*/
	
	nidz=idz_in_form[idz_index];

	nenizast=true;
	for(i=0;i<n;i++){//nacitame idz
	  rec_arr+=sizeof(UInt);
	  idz=*((UInt*)rec_arr);
	  rec_arr+=sizeof(UInt);
	  if(nidz==idz){interval=*((UInt*)rec_arr);nenizast=false;}
	}
      }       
      else
      { //dnes nejede
	it_pole[0]=nejede;
	index=1;
      }

      if(nenizast){
	it_pole[0]=nenalzast;
	index=1;
      }

      //hledane idz konecne
      rec_arr=is_lock;

      if(nasel){
	for(i=0;i<(MemPtrSize(rec_arr)/sizeof(rec_v_xs));i++){	   
	  one_rec=(rec_v_xs*)(rec_arr+(sizeof(rec_v_xs)*i));	      
	  if(one_rec->index==idz){
	    SetFieldTextFromPtr(FldSmer,one_rec->nazev);
	    break;
	  }
	}
      }
      else SetFieldTextFromPtr(FldSmer,prazdnystring);

      vyb_radek=-1;
      if(nasel && !nenizast){//plnime List
	index=0;
	lh=-1;
	n=*(UInt*)vyjezdy;
	for(i=0;i<n;i++){
	  vyjezdy+=sizeof(UInt);
	  cas=*(UInt*)vyjezdy+interval;
	  h=cas/60;
	  m=cas%60;

	  
	  if(h==lh){
	    if(StrLen(radek)+2<MAXRADEK){
	      StrCat(radek, " ");
	      MyStrPrintF(name,m);
	      StrCat(radek, name);	
	    }
	    else{
	      if(index<MAXLIST){
		it_pole[index]=TxtTab[index];
		StrCopy(TxtTab[index++],radek);
		StrCopy(radek,"       ");
		MyStrPrintF(name,m);
		StrCat(radek, name);
	      }
	    }
	  }
	  else{
	    if(lh!=-1){
	      if(index<MAXLIST){
		it_pole[index]=TxtTab[index];
		StrCopy(TxtTab[index++],radek);
	      }
	    }
	    lh=h;	    
	    if(h==ted_hodina && vyb_radek==-1){vyb_radek=index;}

	    MyStrPrintF(name,h);
	    StrCat(name,"|");	   
	    StrCopy(radek,name);
	    StrCat(radek," ");
	    MyStrPrintF(name,m);
	    StrCat(radek,name);
	 
	  }
	  hod_in_form[index]=h;
	}
	if(index<MAXLIST){
	  it_pole[index]=TxtTab[index];
	  StrCopy(TxtTab[index++],radek);	
	}
      }
      lp = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, LstIntervaly));         
      LstSetListChoices(lp, it_pole, index);
      LstSetSelection(lp,vyb_radek);
      LstSetTopItem(lp,vyb_radek);
    }      
    
  }
  
 FrmDrawForm(frm);	  
 }

/* Udalosti z posledni formulare - intervaly */
static Boolean interFormEventHandler(EventPtr e){
 Boolean handled=false;
 switch (e->eType)
   {   
   case ctlSelectEvent:
     switch (e->data.ctlEnter.controlID){
        case BtnZpet3: 
	  FrmGotoForm(MainForm);
	  break;
        case BtnZpetL:  
	  FrmGotoForm(VyblForm);
	  break;
        case BtnZpetZ:  
	  FrmGotoForm(VybzForm);              
  	  break;
        case ZmenSmer2:  
	  smer_tam=!smer_tam;
	  updateLstIntervaly();
	  break;
        default:
	  uz_datum=true;
	  updateLstIntervaly();
	  break;
     }
     break;

   case lstSelectEvent:
     uz_datum=true;
     vybr_hodina=LstGetSelection(e->data.lstSelect.pList);
     ted_hodina=hod_in_form[vybr_hodina];
     break;

   case frmOpenEvent:    
     SetFieldTextFromPtr(FldJmenoZastavky2,vybr_zast);
     SetFieldTextFromPtr(FldJmenoLinky2,vybr_linka);
     FrmDrawForm(FrmGetActiveForm());
     dnesek();
     updateLstIntervaly();
     handled=true;    
     break;       
   }
 return(handled);

}



/* Udalosti aplikace */
static Boolean ApplicationEventHandler(EventPtr e)
{
  FormPtr frm;
  Word  formID;
  Boolean handled = false;

  if (e->eType == frmLoadEvent)
    {
      formID = e->data.frmLoad.formID;
      frm = FrmInitForm(formID);
      FrmSetActiveForm (frm);

      switch(formID)
        {
        case MainForm:
          FrmSetEventHandler (frm, MainFormEventHandler);
          break;
        
        case VybzForm:
	  FrmSetEventHandler (frm, vybzFormEventHandler);
	  break;

	case VyblForm:
	  FrmSetEventHandler (frm, vyblFormEventHandler);
	  break;

	case IntervalyForm:
	  FrmSetEventHandler (frm, interFormEventHandler);
	  break;

	}
      handled = true;
    }
  return handled;
}


/* Udalosti smycka */
static void EventLoop (void)
{
 EventType event;
 Word error;
 do
 {
   EvtGetEvent(&event, evtWaitForever);
   if (!SysHandleEvent(&event))
     if(event.eType==keyDownEvent){
       if (!MenuHandleEvent(NULL, &event, &error))
        if (!ApplicationEventHandler(&event))
          FrmDispatchEvent(&event);
          UpdateHledani();
     }
     else{
      if (!MenuHandleEvent(NULL, &event, &error))
        if (!ApplicationEventHandler(&event))
          FrmDispatchEvent(&event);
     }
  }
  while (event.eType != appStopEvent);     
}


/* Konec aplikace */
static void Stop (void)
{

     if(vlin_lock){
	MemPtrUnlock(vlin_lock);
	vlin_lock=NULL;
      }
      if(soubor_vyb_linky){
	DmCloseDatabase(soubor_vyb_linky);
	soubor_vyb_linky=NULL;
      }
      if(is_lock){
	MemPtrUnlock(is_lock);
	is_lock=NULL;
      }
      if(soubor_is){
	DmCloseDatabase(soubor_is);
	soubor_is=NULL;
      }
      if(js_lock){
	MemPtrUnlock(js_lock);
	js_lock=NULL;
      }
      if(soubor_js){
	DmCloseDatabase(soubor_js);
	soubor_js=NULL;
      }
      if(lin_lock){
	MemPtrUnlock(lin_lock);
	lin_lock=NULL;
      }
      if(soubor_lin){
	DmCloseDatabase(soubor_lin);
	soubor_lin=NULL;
      }
}

/* Zacatek programu */
DWord PilotMain (Word cmd, Ptr cmdPBP, Word Flags)
{
 if (cmd == sysAppLaunchCmdNormalLaunch)
   {
     if (Start())  EventLoop();
     Stop();
    
   }
}



